# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ........core.datetime_utils import serialize_datetime
from ........core.pydantic_utilities import deep_union_pydantic_dicts
from .coverage_details import CoverageDetails
from .service_coverage_details import ServiceCoverageDetails
from .service_type_code import ServiceTypeCode


class ServiceCoverage(pydantic.BaseModel):
    service_code: ServiceTypeCode
    in_network: typing.Optional[ServiceCoverageDetails] = None
    in_network_flat: typing.Optional[typing.List[CoverageDetails]] = None
    out_of_network: typing.Optional[ServiceCoverageDetails] = None
    out_of_network_flat: typing.Optional[typing.List[CoverageDetails]] = None

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults_exclude_unset: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        kwargs_with_defaults_exclude_none: typing.Any = {"by_alias": True, "exclude_none": True, **kwargs}

        return deep_union_pydantic_dicts(
            super().dict(**kwargs_with_defaults_exclude_unset), super().dict(**kwargs_with_defaults_exclude_none)
        )

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
